Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVM.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVM.cpp	(revision 90614)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVM.cpp	(revision 90617)
@@ -37,4 +37,5 @@
     , m_snapshot(snapshot)
     , m_strGroup(strGroup)
+    , m_iCloneModePageIndex(-1)
 {
 #ifndef VBOX_WS_MAC
@@ -45,4 +46,11 @@
     setPixmapName(":/wizard_clone_bg.png");
 #endif /* VBOX_WS_MAC */
+}
+
+void UIWizardCloneVM::setCloneModePageVisible(bool fIsFullClone)
+{
+    if (m_iCloneModePageIndex == -1)
+        return;
+    setPageVisible(m_iCloneModePageIndex, fIsFullClone);
 }
 
@@ -182,5 +190,5 @@
             addPage(new UIWizardCloneVMPageBasic2(m_snapshot.isNull()));
             if (m_machine.GetSnapshotCount() > 0)
-                addPage(new UIWizardCloneVMPageBasic3(m_snapshot.isNull() ? false : m_snapshot.GetChildrenCount() > 0));
+                m_iCloneModePageIndex = addPage(new UIWizardCloneVMPageBasic3(m_snapshot.isNull() ? false : m_snapshot.GetChildrenCount() > 0));
             break;
         }
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVM.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVM.h	(revision 90614)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVM.h	(revision 90617)
@@ -42,4 +42,5 @@
     UIWizardCloneVM(QWidget *pParent, const CMachine &machine,
                     const QString &strGroup, CSnapshot snapshot = CSnapshot());
+    void setCloneModePageVisible(bool fIsFullClone);
 
 protected:
@@ -61,4 +62,5 @@
     CSnapshot m_snapshot;
     QString   m_strGroup;
+    int m_iCloneModePageIndex;
 };
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMPageBasic2.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMPageBasic2.cpp	(revision 90614)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMPageBasic2.cpp	(revision 90617)
@@ -64,4 +64,6 @@
         m_pCloneTypeGroupBox->setFlat(true);
         pMainLayout->addWidget(m_pCloneTypeGroupBox);
+        connect(m_pCloneTypeGroupBox, &UICloneVMCloneTypeGroupBox::sigFullCloneSelected,
+                this, &UIWizardCloneVMPageBasic2::sltCloneTypeChanged);
     }
 
@@ -73,5 +75,7 @@
 void UIWizardCloneVMPageBasic2::sltButtonClicked(QAbstractButton * /* pButton */)
 {
-    //setFinalPage(pButton != m_pFullCloneRadio);
+    UIWizardCloneVM *pWizard = qobject_cast<UIWizardCloneVM*>(wizard());
+    AssertReturnVoid(pWizard);
+    pWizard->setCloneModePageVisible(fIsFullClone);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMPageBasic2.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMPageBasic2.h	(revision 90614)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMPageBasic2.h	(revision 90617)
@@ -61,6 +61,5 @@
 private slots:
 
-    /* Button click handler: */
-    void sltButtonClicked(QAbstractButton *pButton);
+    void sltCloneTypeChanged(bool fIsFullClone);
 
 private:
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardCloneVMEditors.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardCloneVMEditors.cpp	(revision 90614)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardCloneVMEditors.cpp	(revision 90617)
@@ -354,4 +354,7 @@
     }
 
+    connect(m_pButtonGroup, static_cast<void(QButtonGroup::*)(QAbstractButton *)>(&QButtonGroup::buttonClicked),
+            this, &UICloneVMCloneTypeGroupBox::sltButtonClicked);
+
     retranslateUi();
 }
@@ -364,4 +367,9 @@
         m_pLinkedCloneRadio->setText(tr("&Linked clone"));
 
+}
+
+void UICloneVMCloneTypeGroupBox::sltButtonClicked(QAbstractButton *)
+{
+    emit sigFullCloneSelected(m_pFullCloneRadio && m_pFullCloneRadio->isChecked());
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardCloneVMEditors.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardCloneVMEditors.h	(revision 90614)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardCloneVMEditors.h	(revision 90617)
@@ -32,4 +32,5 @@
 /* Forward declarations: */
 // class CMediumFormat;
+class QAbstractButton;
 class QButtonGroup;
 class QCheckBox;
@@ -140,7 +141,13 @@
 signals:
 
+    void sigFullCloneSelected(bool fSelected);
+
 public:
 
     UICloneVMCloneTypeGroupBox(QWidget *pParent = 0);
+
+private slots:
+
+    void sltButtonClicked(QAbstractButton *);
 
 private: