Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPopupCenter.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPopupCenter.cpp	(revision 90694)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPopupCenter.cpp	(revision 90695)
@@ -421,136 +421,2 @@
     pParent->window()->removeEventFilter(pPopupStack);
 }
-
-void UIPopupCenter::cannotAttachUSBDevice(QWidget *pParent, const CConsole &comConsole, const QString &strDevice)
-{
-    alertWithDetails(pParent, "cannotAttachUSBDevice",
-                     QApplication::translate("UIMessageCenter",
-                                             "Failed to attach the USB device <b>%1</b> to the virtual machine <b>%2</b>.")
-                                             .arg(strDevice, CConsole(comConsole).GetMachine().GetName()),
-                     UIErrorString::formatErrorInfo(comConsole));
-}
-
-void UIPopupCenter::cannotAttachUSBDevice(QWidget *pParent, const CVirtualBoxErrorInfo &comErrorInfo,
-                                          const QString &strDevice, const QString &strMachineName)
-{
-    alertWithDetails(pParent, "cannotAttachUSBDevice",
-                     QApplication::translate("UIMessageCenter",
-                                             "Failed to attach the USB device <b>%1</b> to the virtual machine <b>%2</b>.")
-                                             .arg(strDevice).arg(strMachineName),
-                     UIErrorString::formatErrorInfo(comErrorInfo));
-}
-
-void UIPopupCenter::cannotDetachUSBDevice(QWidget *pParent, const CConsole &comConsole, const QString &strDevice)
-{
-    alertWithDetails(pParent, "cannotDetachUSBDevice",
-                     QApplication::translate("UIMessageCenter",
-                                             "Failed to detach the USB device <b>%1</b> from the virtual machine <b>%2</b>.")
-                                             .arg(strDevice, CConsole(comConsole).GetMachine().GetName()),
-                     UIErrorString::formatErrorInfo(comConsole));
-}
-
-void UIPopupCenter::cannotDetachUSBDevice(QWidget *pParent, const CVirtualBoxErrorInfo &comErrorInfo,
-                                          const QString &strDevice, const QString &strMachineName)
-{
-    alertWithDetails(pParent, "cannotDetachUSBDevice",
-                     QApplication::translate("UIMessageCenter",
-                                             "Failed to detach the USB device <b>%1</b> from the virtual machine <b>%2</b>.")
-                                             .arg(strDevice, strMachineName),
-                     UIErrorString::formatErrorInfo(comErrorInfo));
-}
-
-void UIPopupCenter::cannotAttachWebCam(QWidget *pParent, const CEmulatedUSB &comDispatcher,
-                                       const QString &strWebCamName, const QString &strMachineName)
-{
-    alertWithDetails(pParent, "cannotAttachWebCam",
-                     QApplication::translate("UIMessageCenter",
-                                             "Failed to attach the webcam <b>%1</b> to the virtual machine <b>%2</b>.")
-                                             .arg(strWebCamName, strMachineName),
-                     UIErrorString::formatErrorInfo(comDispatcher));
-}
-
-void UIPopupCenter::cannotDetachWebCam(QWidget *pParent, const CEmulatedUSB &comDispatcher,
-                                       const QString &strWebCamName, const QString &strMachineName)
-{
-    alertWithDetails(pParent, "cannotDetachWebCam",
-                     QApplication::translate("UIMessageCenter",
-                                             "Failed to detach the webcam <b>%1</b> from the virtual machine <b>%2</b>.")
-                                             .arg(strWebCamName, strMachineName),
-                     UIErrorString::formatErrorInfo(comDispatcher));
-}
-
-void UIPopupCenter::cannotToggleRecording(QWidget *pParent, const CMachine &comMachine, bool fEnable)
-{
-    /* Get machine-name preserving error-info: */
-    QString strMachineName(CMachine(comMachine).GetName());
-    alertWithDetails(pParent, "cannotToggleRecording",
-                     fEnable ?
-                     QApplication::translate("UIMessageCenter", "Failed to enable recording for the virtual machine <b>%1</b>.").arg(strMachineName) :
-                     QApplication::translate("UIMessageCenter", "Failed to disable recording for the virtual machine <b>%1</b>.").arg(strMachineName),
-                     UIErrorString::formatErrorInfo(comMachine));
-}
-
-void UIPopupCenter::cannotToggleVRDEServer(QWidget *pParent, const CVRDEServer &comServer, const QString &strMachineName, bool fEnable)
-{
-    alertWithDetails(pParent, "cannotToggleVRDEServer",
-                     fEnable ?
-                     QApplication::translate("UIMessageCenter", "Failed to enable the remote desktop server for the virtual machine <b>%1</b>.").arg(strMachineName) :
-                     QApplication::translate("UIMessageCenter", "Failed to disable the remote desktop server for the virtual machine <b>%1</b>.").arg(strMachineName),
-                     UIErrorString::formatErrorInfo(comServer));
-}
-
-void UIPopupCenter::cannotToggleNetworkAdapterCable(QWidget *pParent, const CNetworkAdapter &comAdapter, const QString &strMachineName, bool fConnect)
-{
-    alertWithDetails(pParent, "cannotToggleNetworkAdapterCable",
-                     fConnect ?
-                     QApplication::translate("UIMessageCenter", "Failed to connect the network adapter cable of the virtual machine <b>%1</b>.").arg(strMachineName) :
-                     QApplication::translate("UIMessageCenter", "Failed to disconnect the network adapter cable of the virtual machine <b>%1</b>.").arg(strMachineName),
-                     UIErrorString::formatErrorInfo(comAdapter));
-}
-
-void UIPopupCenter::cannotToggleAudioOutput(QWidget *pParent, const CAudioAdapter &comAdapter, const QString &strMachineName, bool fEnable)
-{
-    alertWithDetails(pParent, "cannotToggleAudioOutput",
-                     fEnable ?
-                     QApplication::translate("UIMessageCenter", "Failed to enable the audio adapter output for the virtual machine <b>%1</b>.").arg(strMachineName) :
-                     QApplication::translate("UIMessageCenter", "Failed to disable the audio adapter output for the virtual machine <b>%1</b>.").arg(strMachineName),
-                     UIErrorString::formatErrorInfo(comAdapter));
-}
-
-void UIPopupCenter::cannotToggleAudioInput(QWidget *pParent, const CAudioAdapter &comAdapter, const QString &strMachineName, bool fEnable)
-{
-    alertWithDetails(pParent, "cannotToggleAudioInput",
-                     fEnable ?
-                     QApplication::translate("UIMessageCenter", "Failed to enable the audio adapter input for the virtual machine <b>%1</b>.").arg(strMachineName) :
-                     QApplication::translate("UIMessageCenter", "Failed to disable the audio adapter input for the virtual machine <b>%1</b>.").arg(strMachineName),
-                     UIErrorString::formatErrorInfo(comAdapter));
-}
-
-void UIPopupCenter::cannotMountImage(QWidget *pParent, const QString &strMachineName, const QString &strMediumName)
-{
-    alert(pParent, "cannotMountImage",
-          QApplication::translate("UIMessageCenter",
-                                  "<p>Could not insert the <b>%1</b> disk image file into the virtual machine <b>%2</b>, "
-                                  "as the machine has no optical drives. Please add a drive using the storage page of the "
-                                  "virtual machine settings window.</p>")
-                                  .arg(strMediumName, strMachineName));
-}
-
-void UIPopupCenter::cannotOpenMedium(QWidget *pParent, const CVirtualBox &comVBox, UIMediumDeviceType /* enmType */, const QString &strLocation)
-{
-    alertWithDetails(pParent, "cannotOpenMedium",
-                     QApplication::translate("UIMessageCenter",
-                                             "Failed to open the disk image file <nobr><b>%1</b></nobr>.")
-                                             .arg(strLocation),
-                     UIErrorString::formatErrorInfo(comVBox));
-}
-
-void UIPopupCenter::cannotSaveMachineSettings(QWidget *pParent, const CMachine &comMachine)
-{
-    alertWithDetails(pParent, "cannotSaveMachineSettings",
-                     QApplication::translate("UIMessageCenter",
-                                             "Failed to save the settings of the virtual machine <b>%1</b> to <b><nobr>%2</nobr></b>.")
-                                             .arg(CMachine(comMachine).GetName(), CMachine(comMachine).GetSettingsFilePath()),
-                     UIErrorString::formatErrorInfo(comMachine));
-}
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPopupCenter.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPopupCenter.h	(revision 90694)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPopupCenter.h	(revision 90695)
@@ -147,28 +147,4 @@
     void recall(QWidget *pParent, const QString &strID);
 
-    /* API: Runtime UI stuff: */
-    void cannotAttachUSBDevice(QWidget *pParent, const CConsole &comConsole, const QString &strDevice);
-    void cannotAttachUSBDevice(QWidget *pParent, const CVirtualBoxErrorInfo &comErrorInfo,
-                               const QString &strDevice, const QString &strMachineName);
-    void cannotDetachUSBDevice(QWidget *pParent, const CConsole &comConsole, const QString &strDevice);
-    void cannotDetachUSBDevice(QWidget *pParent, const CVirtualBoxErrorInfo &comErrorInfo,
-                               const QString &strDevice, const QString &strMachineName);
-    void cannotAttachWebCam(QWidget *pParent, const CEmulatedUSB &comDispatcher,
-                            const QString &strWebCamName, const QString &strMachineName);
-    void cannotDetachWebCam(QWidget *pParent, const CEmulatedUSB &comDispatcher,
-                            const QString &strWebCamName, const QString &strMachineName);
-    void cannotToggleRecording(QWidget *pParent, const CMachine &comMachine, bool fEnable);
-    void cannotToggleVRDEServer(QWidget *pParent,  const CVRDEServer &comServer,
-                                const QString &strMachineName, bool fEnable);
-    void cannotToggleNetworkAdapterCable(QWidget *pParent, const CNetworkAdapter &comAdapter,
-                                         const QString &strMachineName, bool fConnect);
-    void cannotToggleAudioOutput(QWidget *pParent, const CAudioAdapter &comAdapter,
-                                 const QString &strMachineName, bool fEnable);
-    void cannotToggleAudioInput(QWidget *pParent, const CAudioAdapter &comAdapter,
-                                const QString &strMachineName, bool fEnable);
-    void cannotMountImage(QWidget *pParent, const QString &strMachineName, const QString &strMediumName);
-    void cannotOpenMedium(QWidget *pParent, const CVirtualBox &comVBox, UIMediumDeviceType enmType, const QString &strLocation);
-    void cannotSaveMachineSettings(QWidget *pParent, const CMachine &comMachine);
-
 private slots:
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.cpp	(revision 90694)
+++ trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.cpp	(revision 90695)
@@ -22,4 +22,5 @@
 /* GUI includes: */
 #include "UICommon.h"
+#include "UIErrorString.h"
 #include "UIExtraDataManager.h"
 #include "UIHostComboEditor.h"
@@ -34,5 +35,9 @@
 
 /* COM includes: */
+#include "CAudioAdapter.h"
 #include "CConsole.h"
+#include "CEmulatedUSB.h"
+#include "CNetworkAdapter.h"
+#include "CVRDEServer.h"
 
 
@@ -43,4 +48,15 @@
 /* static */
 QMap<QString, QUuid> UINotificationMessage::m_messages = QMap<QString, QUuid>();
+
+/* static */
+void UINotificationMessage::cannotMountImage(const QString &strMachineName, const QString &strMediumName)
+{
+    createMessage(
+        QApplication::translate("UIMessageCenter", "Can't mount image ..."),
+        QApplication::translate("UIMessageCenter", "<p>Could not insert the <b>%1</b> disk image file into the virtual machine "
+                                                   "<b>%2</b>, as the machine has no optical drives. Please add a drive using "
+                                                   "the storage page of the virtual machine settings window.</p>")
+                                                   .arg(strMediumName, strMachineName));
+}
 
 /* static */
@@ -148,4 +164,5 @@
 }
 
+/* static */
 void UINotificationMessage::remindAboutGuestAdditionsAreNotActive()
 {
@@ -162,4 +179,160 @@
 }
 
+/* static */
+void UINotificationMessage::cannotAttachUSBDevice(const CConsole &comConsole, const QString &strDevice)
+{
+    createMessage(
+        QApplication::translate("UIMessageCenter", "Can't attach USB device ..."),
+        QApplication::translate("UIMessageCenter", "Failed to attach the USB device <b>%1</b> to the virtual machine <b>%2</b>.")
+                                .arg(strDevice, CConsole(comConsole).GetMachine().GetName()) +
+        UIErrorString::formatErrorInfo(comConsole));
+}
+
+/* static */
+void UINotificationMessage::cannotAttachUSBDevice(const CVirtualBoxErrorInfo &comErrorInfo,
+                                                  const QString &strDevice, const QString &strMachineName)
+{
+    createMessage(
+        QApplication::translate("UIMessageCenter", "Can't attach USB device ..."),
+        QApplication::translate("UIMessageCenter", "Failed to attach the USB device <b>%1</b> to the virtual machine <b>%2</b>.")
+                                .arg(strDevice, strMachineName) +
+        UIErrorString::formatErrorInfo(comErrorInfo));
+}
+
+/* static */
+void UINotificationMessage::cannotDetachUSBDevice(const CConsole &comConsole, const QString &strDevice)
+{
+    createMessage(
+        QApplication::translate("UIMessageCenter", "Can't detach USB device ..."),
+        QApplication::translate("UIMessageCenter", "Failed to detach the USB device <b>%1</b> from the virtual machine <b>%2</b>.")
+                                .arg(strDevice, CConsole(comConsole).GetMachine().GetName()) +
+        UIErrorString::formatErrorInfo(comConsole));
+}
+
+/* static */
+void UINotificationMessage::cannotDetachUSBDevice(const CVirtualBoxErrorInfo &comErrorInfo,
+                                                  const QString &strDevice, const QString &strMachineName)
+{
+    createMessage(
+        QApplication::translate("UIMessageCenter", "Can't detach USB device ..."),
+        QApplication::translate("UIMessageCenter", "Failed to detach the USB device <b>%1</b> from the virtual machine <b>%2</b>.")
+                                .arg(strDevice, strMachineName) +
+        UIErrorString::formatErrorInfo(comErrorInfo));
+}
+
+/* static */
+void UINotificationMessage::cannotAttachWebCam(const CEmulatedUSB &comDispatcher,
+                                               const QString &strWebCamName, const QString &strMachineName)
+{
+    createMessage(
+        QApplication::translate("UIMessageCenter", "Can't attach webcam ..."),
+        QApplication::translate("UIMessageCenter", "Failed to attach the webcam <b>%1</b> to the virtual machine <b>%2</b>.")
+                                .arg(strWebCamName, strMachineName) +
+        UIErrorString::formatErrorInfo(comDispatcher));
+}
+
+/* static */
+void UINotificationMessage::cannotDetachWebCam(const CEmulatedUSB &comDispatcher,
+                                               const QString &strWebCamName, const QString &strMachineName)
+{
+    createMessage(
+        QApplication::translate("UIMessageCenter", "Can't detach webcam ..."),
+        QApplication::translate("UIMessageCenter", "Failed to detach the webcam <b>%1</b> from the virtual machine <b>%2</b>.")
+                                .arg(strWebCamName, strMachineName) +
+        UIErrorString::formatErrorInfo(comDispatcher));
+}
+
+/* static */
+void UINotificationMessage::cannotOpenMedium(const CVirtualBox &comVBox, const QString &strLocation)
+{
+    createMessage(
+        QApplication::translate("UIMessageCenter", "Can't open medium ..."),
+        QApplication::translate("UIMessageCenter", "Failed to open the disk image file <nobr><b>%1</b></nobr>.")
+                                                   .arg(strLocation) +
+        UIErrorString::formatErrorInfo(comVBox));
+}
+
+/* static */
+void UINotificationMessage::cannotSaveMachineSettings(const CMachine &comMachine)
+{
+    createMessage(
+        QApplication::translate("UIMessageCenter", "Can't save machine settings ..."),
+        QApplication::translate("UIMessageCenter", "Failed to save the settings of the virtual machine <b>%1</b> to "
+                                                   "<b><nobr>%2</nobr></b>.")
+                                                   .arg(CMachine(comMachine).GetName(),
+                                                        CMachine(comMachine).GetSettingsFilePath()) +
+        UIErrorString::formatErrorInfo(comMachine));
+}
+
+/* static */
+void UINotificationMessage::cannotToggleAudioInput(const CAudioAdapter &comAdapter,
+                                                   const QString &strMachineName, bool fEnable)
+{
+    createMessage(
+        QApplication::translate("UIMessageCenter", "Can't toggle audio input ..."),
+        (  fEnable
+         ? QApplication::translate("UIMessageCenter", "Failed to enable the audio adapter input for the virtual machine <b>%1</b>.")
+                                   .arg(strMachineName)
+         : QApplication::translate("UIMessageCenter", "Failed to disable the audio adapter input for the virtual machine <b>%1</b>.")
+                                   .arg(strMachineName)) +
+        UIErrorString::formatErrorInfo(comAdapter));
+}
+
+/* static */
+void UINotificationMessage::cannotToggleAudioOutput(const CAudioAdapter &comAdapter,
+                                                    const QString &strMachineName, bool fEnable)
+{
+    createMessage(
+        QApplication::translate("UIMessageCenter", "Can't toggle audio output ..."),
+        (  fEnable
+         ? QApplication::translate("UIMessageCenter", "Failed to enable the audio adapter output for the virtual machine <b>%1</b>.")
+                                   .arg(strMachineName)
+         : QApplication::translate("UIMessageCenter", "Failed to disable the audio adapter output for the virtual machine <b>%1</b>.")
+                                   .arg(strMachineName)) +
+        UIErrorString::formatErrorInfo(comAdapter));
+}
+
+/* static */
+void UINotificationMessage::cannotToggleNetworkCable(const CNetworkAdapter &comAdapter,
+                                                     const QString &strMachineName, bool fConnect)
+{
+    createMessage(
+        QApplication::translate("UIMessageCenter", "Can't toggle network cable ..."),
+        (  fConnect
+         ? QApplication::translate("UIMessageCenter", "Failed to connect the network adapter cable of the virtual machine <b>%1</b>.")
+                                   .arg(strMachineName)
+         : QApplication::translate("UIMessageCenter", "Failed to disconnect the network adapter cable of the virtual machine <b>%1</b>.")
+                                   .arg(strMachineName)) +
+        UIErrorString::formatErrorInfo(comAdapter));
+}
+
+/* static */
+void UINotificationMessage::cannotToggleRecording(const CMachine &comMachine, bool fEnable)
+{
+    const QString strMachineName(CMachine(comMachine).GetName());
+    createMessage(
+        QApplication::translate("UIMessageCenter", "Can't toggle recording ..."),
+        (  fEnable
+         ? QApplication::translate("UIMessageCenter", "Failed to enable recording for the virtual machine <b>%1</b>.")
+                                   .arg(strMachineName)
+         : QApplication::translate("UIMessageCenter", "Failed to disable recording for the virtual machine <b>%1</b>.")
+                                   .arg(strMachineName)) +
+        UIErrorString::formatErrorInfo(comMachine));
+}
+
+/* static */
+void UINotificationMessage::cannotToggleVRDEServer(const CVRDEServer &comServer,
+                                                   const QString &strMachineName, bool fEnable)
+{
+    createMessage(
+        QApplication::translate("UIMessageCenter", "Can't toggle VRDE server ..."),
+        (  fEnable
+         ? QApplication::translate("UIMessageCenter", "Failed to enable the remote desktop server for the virtual machine <b>%1</b>.")
+                                   .arg(strMachineName)
+         : QApplication::translate("UIMessageCenter", "Failed to disable the remote desktop server for the virtual machine <b>%1</b>.")
+                                   .arg(strMachineName)) +
+        UIErrorString::formatErrorInfo(comServer));
+}
+
 UINotificationMessage::UINotificationMessage(const QString &strName,
                                              const QString &strDetails,
Index: trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.h	(revision 90694)
+++ trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.h	(revision 90695)
@@ -44,4 +44,13 @@
 #include "CVirtualSystemDescription.h"
 
+/* Forward declarations: */
+class CAudioAdapter;
+class CConsole;
+class CEmulatedUSB;
+class CNetworkAdapter;
+class CVirtualBox;
+class CVirtualBoxErrorInfo;
+class CVRDEServer;
+
 /** UINotificationObject extension for message functionality. */
 class SHARED_LIBRARY_STUFF UINotificationMessage : public UINotificationSimple
@@ -51,4 +60,8 @@
 public:
 
+    /** Notifies about inability to mount image.
+      * @param  strMachineName  Brings the machine name.
+      * @param  strMediumName   Brings the medium name. */
+    static void cannotMountImage(const QString &strMachineName, const QString &strMediumName);
     /** Notifies about inability to send ACPI shutdown. */
     static void cannotSendACPIToMachine();
@@ -72,4 +85,72 @@
     static void remindAboutGuestAdditionsAreNotActive();
 
+    /** Notifies about inability to attach USB device.
+      * @param  comConsole  Brings console USB device belongs to.
+      * @param  strDevice   Brings the device name. */
+    static void cannotAttachUSBDevice(const CConsole &comConsole, const QString &strDevice);
+    /** Notifies about inability to attach USB device.
+      * @param  comErrorInfo    Brings info about error happened.
+      * @param  strDevice       Brings the device name.
+      * @param  strMachineName  Brings the machine name. */
+    static void cannotAttachUSBDevice(const CVirtualBoxErrorInfo &comErrorInfo,
+                                      const QString &strDevice, const QString &strMachineName);
+    /** Notifies about inability to detach USB device.
+      * @param  comConsole  Brings console USB device belongs to.
+      * @param  strDevice   Brings the device name. */
+    static void cannotDetachUSBDevice(const CConsole &comConsole, const QString &strDevice);
+    /** Notifies about inability to detach USB device.
+      * @param  comErrorInfo    Brings info about error happened.
+      * @param  strDevice       Brings the device name.
+      * @param  strMachineName  Brings the machine name. */
+    static void cannotDetachUSBDevice(const CVirtualBoxErrorInfo &comErrorInfo,
+                                      const QString &strDevice, const QString &strMachineName);
+    /** Notifies about inability to attach webcam.
+      * @param  comDispatcher   Brings emulated USB dispatcher webcam being attached to.
+      * @param  strWebCamName   Brings the webcam name.
+      * @param  strMachineName  Brings the machine name. */
+    static void cannotAttachWebCam(const CEmulatedUSB &comDispatcher,
+                                   const QString &strWebCamName, const QString &strMachineName);
+    /** Notifies about inability to detach webcam.
+      * @param  comDispatcher   Brings emulated USB dispatcher webcam being detached from.
+      * @param  strWebCamName   Brings the webcam name.
+      * @param  strMachineName  Brings the machine name. */
+    static void cannotDetachWebCam(const CEmulatedUSB &comDispatcher,
+                                   const QString &strWebCamName, const QString &strMachineName);
+    /** Notifies about inability to open medium.
+      * @param  comVBox      Brings common VBox object trying to open medium.
+      * @param  strLocation  Brings the medium location. */
+    static void cannotOpenMedium(const CVirtualBox &comVBox, const QString &strLocation);
+    /** Notifies about inability to save machine settings.
+      * @param  comMachine  Brings the machine trying to save settings. */
+    static void cannotSaveMachineSettings(const CMachine &comMachine);
+    /** Notifies about inability to toggle audio input.
+      * @param  comAdapter      Brings the adapter input being toggled for.
+      * @param  strMachineName  Brings the machine name.
+      * @param  fEnable         Brings whether adapter input is enabled or not. */
+    static void cannotToggleAudioInput(const CAudioAdapter &comAdapter,
+                                       const QString &strMachineName, bool fEnable);
+    /** Notifies about inability to toggle audio output.
+      * @param  comAdapter      Brings the adapter output being toggled for.
+      * @param  strMachineName  Brings the machine name.
+      * @param  fEnable         Brings whether adapter output is enabled or not. */
+    static void cannotToggleAudioOutput(const CAudioAdapter &comAdapter,
+                                        const QString &strMachineName, bool fEnable);
+    /** Notifies about inability to toggle network cable.
+      * @param  comAdapter      Brings the adapter network cable being toggled for.
+      * @param  strMachineName  Brings the machine name.
+      * @param  fConnect        Brings whether network cable is connected or not. */
+    static void cannotToggleNetworkCable(const CNetworkAdapter &comAdapter,
+                                         const QString &strMachineName, bool fConnect);
+    /** Notifies about inability to toggle recording.
+      * @param  comMachine  Brings the machine recording being toggled for.
+      * @param  fEnable     Brings whether recording is enabled or not. */
+    static void cannotToggleRecording(const CMachine &comMachine, bool fEnable);
+    /** Notifies about inability to toggle VRDE server.
+      * @param  comServer       Brings the server being toggled.
+      * @param  strMachineName  Brings the machine name.
+      * @param  fEnable         Brings whether server is enabled or not. */
+    static void cannotToggleVRDEServer(const CVRDEServer &comServer,
+                                       const QString &strMachineName, bool fEnable);
+
 protected:
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 90694)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 90695)
@@ -755,7 +755,7 @@
     {
         if (fIsAttached)
-            popupCenter().cannotAttachUSBDevice(activeMachineWindow(), error, uiCommon().details(device), machineName());
+            UINotificationMessage::cannotAttachUSBDevice(error, uiCommon().details(device), machineName());
         else
-            popupCenter().cannotDetachUSBDevice(activeMachineWindow(), error, uiCommon().details(device), machineName());
+            UINotificationMessage::cannotDetachUSBDevice(error, uiCommon().details(device), machineName());
     }
 }
@@ -2176,5 +2176,5 @@
         uisession()->updateStatusRecording();
         /* Notify about the error: */
-        return popupCenter().cannotToggleRecording(activeMachineWindow(), machine(), fEnabled);
+        return UINotificationMessage::cannotToggleRecording(machine(), fEnabled);
     }
 
@@ -2186,5 +2186,5 @@
         uisession()->updateStatusRecording();
         /* Notify about the error: */
-        return msgCenter().cannotSaveMachineSettings(machine());
+        return UINotificationMessage::cannotSaveMachineSettings(machine());
     }
 }
@@ -2212,5 +2212,5 @@
         uisession()->updateStatusVRDE();
         /* Notify about the error: */
-        return popupCenter().cannotToggleVRDEServer(activeMachineWindow(), server, machineName(), fEnabled);
+        return UINotificationMessage::cannotToggleVRDEServer(server, machineName(), fEnabled);
     }
 
@@ -2222,5 +2222,5 @@
         uisession()->updateStatusVRDE();
         /* Notify about the error: */
-        return msgCenter().cannotSaveMachineSettings(machine());
+        return UINotificationMessage::cannotSaveMachineSettings(machine());
     }
 }
@@ -2288,5 +2288,5 @@
         uisession()->updateAudioOutput();
         /* Notify about the error: */
-        return popupCenter().cannotToggleAudioOutput(activeMachineWindow(), comAdapter, machineName(), fEnabled);
+        return UINotificationMessage::cannotToggleAudioOutput(comAdapter, machineName(), fEnabled);
     }
 
@@ -2298,5 +2298,5 @@
         uisession()->updateAudioOutput();
         /* Notify about the error: */
-        return msgCenter().cannotSaveMachineSettings(machine());
+        return UINotificationMessage::cannotSaveMachineSettings(machine());
     }
 }
@@ -2324,5 +2324,5 @@
         uisession()->updateAudioInput();
         /* Notify about the error: */
-        return popupCenter().cannotToggleAudioInput(activeMachineWindow(), comAdapter, machineName(), fEnabled);
+        return UINotificationMessage::cannotToggleAudioInput(comAdapter, machineName(), fEnabled);
     }
 
@@ -2334,5 +2334,5 @@
         uisession()->updateAudioInput();
         /* Notify about the error: */
-        return msgCenter().cannotSaveMachineSettings(machine());
+        return UINotificationMessage::cannotSaveMachineSettings(machine());
     }
 }
@@ -2397,5 +2397,5 @@
             CUSBDevice device(hostDevice);
             /* Show a message about procedure failure: */
-            popupCenter().cannotAttachUSBDevice(activeMachineWindow(), console(), uiCommon().details(device));
+            UINotificationMessage::cannotAttachUSBDevice(console(), uiCommon().details(device));
         }
     }
@@ -2411,5 +2411,5 @@
         {
             /* Show a message about procedure failure: */
-            popupCenter().cannotDetachUSBDevice(activeMachineWindow(), console(), uiCommon().details(device));
+            UINotificationMessage::cannotDetachUSBDevice(console(), uiCommon().details(device));
         }
     }
@@ -2435,5 +2435,5 @@
         /* Check if dispatcher is OK: */
         if (!dispatcher.isOk())
-            popupCenter().cannotAttachWebCam(activeMachineWindow(), dispatcher, target.name, machineName());
+            UINotificationMessage::cannotAttachWebCam(dispatcher, target.name, machineName());
     }
     /* Detach webcam device: */
@@ -2444,5 +2444,5 @@
         /* Check if dispatcher is OK: */
         if (!dispatcher.isOk())
-            popupCenter().cannotDetachWebCam(activeMachineWindow(), dispatcher, target.name, machineName());
+            UINotificationMessage::cannotDetachWebCam(dispatcher, target.name, machineName());
     }
 }
@@ -2474,10 +2474,10 @@
     adapter.SetCableConnected(fConnect);
     if (!adapter.isOk())
-        return popupCenter().cannotToggleNetworkAdapterCable(activeMachineWindow(), adapter, machineName(), fConnect);
+        return UINotificationMessage::cannotToggleNetworkCable(adapter, machineName(), fConnect);
 
     /* Save machine-settings: */
     machine().SaveSettings();
     if (!machine().isOk())
-        return msgCenter().cannotSaveMachineSettings(machine());
+        return UINotificationMessage::cannotSaveMachineSettings(machine());
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 90694)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 90695)
@@ -46,5 +46,4 @@
 #include "UIMousePointerShapeData.h"
 #include "UINotificationCenter.h"
-#include "UIPopupCenter.h"
 #include "UIWizardFirstRun.h"
 #include "UIConsoleEventHandler.h"
@@ -1819,5 +1818,5 @@
         if (!comVBox.isOk() || comMedium.isNull())
         {
-            popupCenter().cannotOpenMedium(activeMachineWindow(), comVBox, enmMediumType, strMediumName);
+            UINotificationMessage::cannotOpenMedium(comVBox, strMediumName);
             return false;
         }
@@ -1862,5 +1861,5 @@
     if (sStorageSlots.isEmpty())
     {
-        popupCenter().cannotMountImage(activeMachineWindow(), machineName(), strMediumName);
+        UINotificationMessage::cannotMountImage(machineName(), strMediumName);
         return false;
     }
@@ -1888,5 +1887,5 @@
     if (!machine().isOk())
     {
-        popupCenter().cannotSaveMachineSettings(activeMachineWindow(), machine());
+        UINotificationMessage::cannotSaveMachineSettings(machine());
         return false;
     }