Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc	(revision 90722)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc	(revision 90725)
@@ -406,5 +406,8 @@
         <file alias="help_browser_minus_32px.png">images/help_browser_minus_32px.png</file>
         <file alias="help_browser_plus_32px.png">images/help_browser_plus_32px.png</file>
+        <file alias="help_browser_reload_16px.png">images/help_browser_reload_16px.png</file>
         <file alias="help_browser_reload_32px.png">images/help_browser_reload_32px.png</file>
+        <file alias="help_browser_reload_disabled_16px.png">images/help_browser_reload_disabled_16px.png</file>
+        <file alias="help_browser_reload_disabled_32px.png">images/help_browser_reload_disabled_32px.png</file>
         <file alias="help_browser_reset_32px.png">images/help_browser_reset_32px.png</file>
         <file alias="help_browser_search.png">images/help_browser_search.png</file>
@@ -479,5 +482,4 @@
         <file alias="log_viewer_filter_disabled_32px.png">images/log_viewer_filter_disabled_32px.png</file>
         <file alias="log_viewer_find_16px.png">images/log_viewer_find_16px.png</file>
-        <file alias="log_viewer_find_32px.png">images/log_viewer_find_32px.png</file>
     </qresource>
 </RCC>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x2.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x2.qrc	(revision 90722)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x2.qrc	(revision 90725)
@@ -404,4 +404,8 @@
         <file alias="help_browser_home_disabled_16px_x2.png">images/x2/help_browser_home_disabled_16px_x2.png</file>
         <file alias="help_browser_home_disabled_32px_x2.png">images/x2/help_browser_home_disabled_32px_x2.png</file>
+        <file alias="help_browser_reload_16px_x2.png">images/x2/help_browser_reload_16px_x2.png</file>
+        <file alias="help_browser_reload_32px_x2.png">images/x2/help_browser_reload_32px_x2.png</file>
+        <file alias="help_browser_reload_disabled_16px_x2.png">images/x2/help_browser_reload_disabled_16px_x2.png</file>
+        <file alias="help_browser_reload_disabled_32px_x2.png">images/x2/help_browser_reload_disabled_32px_x2.png</file>
         <file alias="help_button_normal_mac_24px_x2.png">images/x2/help_button_normal_mac_24px_x2.png</file>
         <file alias="help_button_pressed_mac_24px_x2.png">images/x2/help_button_pressed_mac_24px_x2.png</file>
@@ -470,6 +474,4 @@
         <file alias="log_viewer_filter_32px_x2.png">images/x2/log_viewer_filter_32px_x2.png</file>
         <file alias="log_viewer_filter_add_16px_x2.png">images/x2/log_viewer_filter_add_16px_x2.png</file>
-        <file alias="log_viewer_filter_disabled_16px_x2.png">images/x2/log_viewer_filter_disabled_16px_x2.png</file>
-        <file alias="log_viewer_filter_disabled_32px_x2.png">images/x2/log_viewer_filter_disabled_32px_x2.png</file>
     </qresource>
 </RCC>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x3.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x3.qrc	(revision 90722)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x3.qrc	(revision 90725)
@@ -404,4 +404,8 @@
         <file alias="help_browser_home_disabled_16px_x3.png">images/x3/help_browser_home_disabled_16px_x3.png</file>
         <file alias="help_browser_home_disabled_32px_x3.png">images/x3/help_browser_home_disabled_32px_x3.png</file>
+        <file alias="help_browser_reload_16px_x3.png">images/x3/help_browser_reload_16px_x3.png</file>
+        <file alias="help_browser_reload_32px_x3.png">images/x3/help_browser_reload_32px_x3.png</file>
+        <file alias="help_browser_reload_disabled_16px_x3.png">images/x3/help_browser_reload_disabled_16px_x3.png</file>
+        <file alias="help_browser_reload_disabled_32px_x3.png">images/x3/help_browser_reload_disabled_32px_x3.png</file>
         <file alias="help_button_normal_mac_24px_x3.png">images/x3/help_button_normal_mac_24px_x3.png</file>
         <file alias="help_button_pressed_mac_24px_x3.png">images/x3/help_button_pressed_mac_24px_x3.png</file>
@@ -470,6 +474,4 @@
         <file alias="log_viewer_filter_32px_x3.png">images/x3/log_viewer_filter_32px_x3.png</file>
         <file alias="log_viewer_filter_add_16px_x3.png">images/x3/log_viewer_filter_add_16px_x3.png</file>
-        <file alias="log_viewer_filter_disabled_16px_x3.png">images/x3/log_viewer_filter_disabled_16px_x3.png</file>
-        <file alias="log_viewer_filter_disabled_32px_x3.png">images/x3/log_viewer_filter_disabled_32px_x3.png</file>
     </qresource>
 </RCC>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x4.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x4.qrc	(revision 90722)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x4.qrc	(revision 90725)
@@ -404,4 +404,8 @@
         <file alias="help_browser_home_disabled_16px_x4.png">images/x4/help_browser_home_disabled_16px_x4.png</file>
         <file alias="help_browser_home_disabled_32px_x4.png">images/x4/help_browser_home_disabled_32px_x4.png</file>
+        <file alias="help_browser_reload_16px_x4.png">images/x4/help_browser_reload_16px_x4.png</file>
+        <file alias="help_browser_reload_32px_x4.png">images/x4/help_browser_reload_32px_x4.png</file>
+        <file alias="help_browser_reload_disabled_16px_x4.png">images/x4/help_browser_reload_disabled_16px_x4.png</file>
+        <file alias="help_browser_reload_disabled_32px_x4.png">images/x4/help_browser_reload_disabled_32px_x4.png</file>
         <file alias="help_button_normal_mac_24px_x4.png">images/x4/help_button_normal_mac_24px_x4.png</file>
         <file alias="help_button_pressed_mac_24px_x4.png">images/x4/help_button_pressed_mac_24px_x4.png</file>
@@ -470,6 +474,4 @@
         <file alias="log_viewer_filter_32px_x4.png">images/x4/log_viewer_filter_32px_x4.png</file>
         <file alias="log_viewer_filter_add_16px_x4.png">images/x4/log_viewer_filter_add_16px_x4.png</file>
-        <file alias="log_viewer_filter_disabled_16px_x4.png">images/x4/log_viewer_filter_disabled_16px_x4.png</file>
-        <file alias="log_viewer_filter_disabled_32px_x4.png">images/x4/log_viewer_filter_disabled_32px_x4.png</file>
     </qresource>
 </RCC>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 90722)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 90725)
@@ -1,4 +1,5 @@
 <RCC>
     <qresource suffix="/">
+        <file alias="log_viewer_find_32px.png">images/log_viewer_find_32px.png</file>
         <file alias="log_viewer_find_disabled_16px.png">images/log_viewer_find_disabled_16px.png</file>
         <file alias="log_viewer_find_disabled_32px.png">images/log_viewer_find_disabled_32px.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x2.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x2.qrc	(revision 90722)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x2.qrc	(revision 90725)
@@ -1,4 +1,6 @@
 <RCC>
     <qresource suffix="/">
+        <file alias="log_viewer_filter_disabled_16px_x2.png">images/x2/log_viewer_filter_disabled_16px_x2.png</file>
+        <file alias="log_viewer_filter_disabled_32px_x2.png">images/x2/log_viewer_filter_disabled_32px_x2.png</file>
         <file alias="log_viewer_find_16px_x2.png">images/x2/log_viewer_find_16px_x2.png</file>
         <file alias="log_viewer_find_32px_x2.png">images/x2/log_viewer_find_32px_x2.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x3.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x3.qrc	(revision 90722)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x3.qrc	(revision 90725)
@@ -1,4 +1,6 @@
 <RCC>
     <qresource suffix="/">
+        <file alias="log_viewer_filter_disabled_16px_x3.png">images/x3/log_viewer_filter_disabled_16px_x3.png</file>
+        <file alias="log_viewer_filter_disabled_32px_x3.png">images/x3/log_viewer_filter_disabled_32px_x3.png</file>
         <file alias="log_viewer_find_16px_x3.png">images/x3/log_viewer_find_16px_x3.png</file>
         <file alias="log_viewer_find_32px_x3.png">images/x3/log_viewer_find_32px_x3.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x4.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x4.qrc	(revision 90722)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x4.qrc	(revision 90725)
@@ -1,4 +1,6 @@
 <RCC>
     <qresource suffix="/">
+        <file alias="log_viewer_filter_disabled_16px_x4.png">images/x4/log_viewer_filter_disabled_16px_x4.png</file>
+        <file alias="log_viewer_filter_disabled_32px_x4.png">images/x4/log_viewer_filter_disabled_32px_x4.png</file>
         <file alias="log_viewer_find_16px_x4.png">images/x4/log_viewer_find_16px_x4.png</file>
         <file alias="log_viewer_find_32px_x4.png">images/x4/log_viewer_find_32px_x4.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.cpp	(revision 90722)
+++ trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.cpp	(revision 90725)
@@ -735,5 +735,6 @@
         new QAction(UIIconPool::iconSet(":/help_browser_search.png"), QString(), this);
     m_pReloadPageAction =
-        new QAction(UIIconPool::iconSet(":/help_browser_reload_32px.png"), QString(), this);
+        new QAction(UIIconPool::iconSetFull(":/help_browser_reload_32px.png", ":/help_browser_reload_16px.png",
+                                            ":/help_browser_reload_disabled_32px.png", ":/help_browser_reload_disabled_16px.png"), QString(), this);
 
     AssertReturnVoid(m_pHomeAction && m_pForwardAction &&
Index: trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpViewer.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpViewer.cpp	(revision 90722)
+++ trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpViewer.cpp	(revision 90725)
@@ -176,5 +176,5 @@
     m_pBackwardButton->setEnabled(false);
     m_pHomeButton->setIcon(UIIconPool::iconSet(":/help_browser_home_16px.png", ":/help_browser_home_disabled_16px.png"));
-    m_pReloadPageButton->setIcon(UIIconPool::iconSet(":/help_browser_reload_32px.png"));
+    m_pReloadPageButton->setIcon(UIIconPool::iconSet(":/help_browser_reload_16px.png", ":/help_browser_reload_disabled_16px.png"));
     m_pForwardButton->setIcon(UIIconPool::iconSet(":/help_browser_forward_16px.png", ":/help_browser_forward_disabled_16px.png"));
     m_pBackwardButton->setIcon(UIIconPool::iconSet(":/help_browser_backward_16px.png", ":/help_browser_backward_disabled_16px.png"));