Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMachineAttributeSetter.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMachineAttributeSetter.cpp	(revision 90757)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMachineAttributeSetter.cpp	(revision 90758)
@@ -24,4 +24,5 @@
 #include "UIMachineAttributeSetter.h"
 #include "UIMessageCenter.h"
+#include "UINotificationCenter.h"
 
 /* COM includes: */
@@ -102,26 +103,4 @@
                 break;
             }
-            case MachineAttribute_Location:
-            {
-                /* Do not save machine settings: */
-                fSaveSettings = false;
-                /* Prepare machine move progress: */
-                CProgress comProgress = comMachine.MoveTo(guiAttribute.toString(), "basic");
-                if (!comMachine.isOk())
-                {
-                    msgCenter().cannotMoveMachine(comMachine);
-                    fErrorHappened = true;
-                    break;
-                }
-                /* Show machine move progress: */
-                msgCenter().showModalProgressDialog(comProgress, comMachine.GetName(), ":/progress_dnd_hg_90px.png");
-                if (!comProgress.isOk() || comProgress.GetResultCode() != 0)
-                {
-                    msgCenter().cannotMoveMachine(comProgress, comMachine.GetName());
-                    fErrorHappened = true;
-                    break;
-                }
-                break;
-            }
             case MachineAttribute_OSType:
             {
@@ -321,2 +300,12 @@
         comSession.UnlockMachine();
 }
+
+void UIMachineAttributeSetter::setMachineLocation(const QUuid &uMachineId,
+                                                  const QString &strLocation)
+{
+    /* Move machine: */
+    UINotificationProgressMachineMove *pNotification = new UINotificationProgressMachineMove(uMachineId,
+                                                                                             strLocation,
+                                                                                             "basic");
+    gpNotificationCenter->append(pNotification);
+}
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMachineAttributeSetter.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMachineAttributeSetter.h	(revision 90757)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMachineAttributeSetter.h	(revision 90758)
@@ -32,5 +32,4 @@
     MachineAttribute_Name,
     MachineAttribute_OSType,
-    MachineAttribute_Location,
     MachineAttribute_BaseMemory,
     MachineAttribute_BootOrder,
@@ -73,4 +72,8 @@
                                                   const MachineAttribute &enmType,
                                                   const QVariant &guiAttribute);
+
+    /** Assigns @a comMachine @a strLocation. */
+    SHARED_LIBRARY_STUFF void setMachineLocation(const QUuid &uMachineId,
+                                                 const QString &strLocation);
 }
 using namespace UIMachineAttributeSetter /* if header included */;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsElement.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsElement.cpp	(revision 90757)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsElement.cpp	(revision 90758)
@@ -908,8 +908,8 @@
             if (fChooseName)
                 setMachineAttribute(machine(), MachineAttribute_Name, QVariant::fromValue(pEditor->name()));
-            else if (fChoosePath)
-                setMachineAttribute(machine(), MachineAttribute_Location, QVariant::fromValue(pEditor->path()));
             else if (fChooseType)
                 setMachineAttribute(machine(), MachineAttribute_OSType, QVariant::fromValue(pEditor->typeId()));
+            else if (fChoosePath)
+                setMachineLocation(machine().GetId(), pEditor->path());
         }
 